"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServerlessTriggerCollector = void 0;
const webRouterCollector_1 = require("./webRouterCollector");
class ServerlessTriggerCollector extends webRouterCollector_1.WebRouterCollector {
    async analyze() {
        this.options.includeFunctionRouter = true;
        await super.analyze();
        // requestMethod all transform to other method
        for (const routerInfo of this.routes.values()) {
            for (const info of routerInfo) {
                if (info.requestMethod === 'all') {
                    info.functionTriggerMetadata.method = [
                        'get',
                        'post',
                        'put',
                        'delete',
                        'head',
                        'patch',
                        'options',
                    ];
                }
            }
        }
    }
    collectRoute(module) {
        super.collectRoute(module, true);
    }
    collectFunctionRoute(module) {
        super.collectFunctionRoute(module, true);
    }
    async getFunctionList() {
        return this.getFlattenRouterTable();
    }
}
exports.ServerlessTriggerCollector = ServerlessTriggerCollector;
//# sourceMappingURL=triggerCollector.js.map