"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MidwayMockService = void 0;
const decorator_1 = require("@midwayjs/decorator");
let MidwayMockService = class MidwayMockService {
    constructor(applicationContext) {
        this.applicationContext = applicationContext;
        this.mocks = [];
        this.contextMocks = [];
        this.cache = new Map();
    }
    mockClassProperty(clzz, propertyName, value) {
        return this.mockProperty(clzz.prototype, propertyName, value);
    }
    mockProperty(obj, key, value) {
        // eslint-disable-next-line no-prototype-builtins
        const hasOwnProperty = obj.hasOwnProperty(key);
        this.mocks.push({
            obj,
            key,
            descriptor: Object.getOwnPropertyDescriptor(obj, key),
            // Make sure the key exists on object not the prototype
            hasOwnProperty,
        });
        // Delete the origin key, redefine it below
        if (hasOwnProperty) {
            delete obj[key];
        }
        // Set a flag that checks if it is mocked
        let flag = this.cache.get(obj);
        if (!flag) {
            flag = new Set();
            this.cache.set(obj, flag);
        }
        flag.add(key);
        const descriptor = this.overridePropertyDescriptor(value);
        Object.defineProperty(obj, key, descriptor);
    }
    mockContext(app, key, value) {
        this.contextMocks.push({
            app,
            key,
            value,
        });
    }
    restore() {
        for (let i = this.mocks.length - 1; i >= 0; i--) {
            const m = this.mocks[i];
            if (!m.hasOwnProperty) {
                // Delete the mock key, use key on the prototype
                delete m.obj[m.key];
            }
            else {
                // Redefine the origin key instead of the mock key
                Object.defineProperty(m.obj, m.key, m.descriptor);
            }
        }
        this.mocks = [];
        this.contextMocks = [];
        this.cache.clear();
    }
    isMocked(obj, key) {
        const flag = this.cache.get(obj);
        return flag ? flag.has(key) : false;
    }
    applyContextMocks(app, ctx) {
        if (this.contextMocks.length > 0) {
            for (const mockItem of this.contextMocks) {
                if (mockItem.app === app) {
                    const descriptor = this.overridePropertyDescriptor(mockItem.value);
                    if (typeof mockItem.key === 'string') {
                        Object.defineProperty(ctx, mockItem.key, descriptor);
                    }
                    else {
                        mockItem.key(ctx);
                    }
                }
            }
        }
    }
    getContextMocksSize() {
        return this.contextMocks.length;
    }
    getMocksSize() {
        return this.mocks.length;
    }
    overridePropertyDescriptor(value) {
        const descriptor = {
            configurable: true,
            enumerable: true,
        };
        if (value && (value.get || value.set)) {
            // Default to undefined
            descriptor.get = value.get;
            descriptor.set = value.set;
        }
        else {
            // Without getter/setter mode
            descriptor.value = value;
            descriptor.writable = true;
        }
        return descriptor;
    }
};
__decorate([
    (0, decorator_1.Destroy)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], MidwayMockService.prototype, "restore", null);
MidwayMockService = __decorate([
    (0, decorator_1.Provide)(),
    (0, decorator_1.Scope)(decorator_1.ScopeEnum.Singleton),
    __metadata("design:paramtypes", [Object])
], MidwayMockService);
exports.MidwayMockService = MidwayMockService;
//# sourceMappingURL=mockService.js.map